using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart;
using Steema.TeeChart.Styles;

namespace SteemaLegendResizeIssue
{
    public partial class Form1 : Form
    {
        private bool bLineWasClicked = false;
        private int NumberOfLines;
        private FastLine flClickedSeries = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Random rnd = new Random();
            int PointCount = 20;
            double[] xData = new double[PointCount];
            double[] yData = new double[PointCount];

            NumberOfLines = 50;

            for(int i = 0; i < PointCount; i++)
            {
                xData[i] = (double)i * 10;
            }


            for (int j = 0; j < NumberOfLines; j++)
            {
                for (int i = 0; i < PointCount; i++)
                {
                    yData[i] = rnd.NextDouble() + j;
                }

                FastLine fl = new FastLine();
                fl.Add(xData, yData);
                this.tChart1.Series.Add(fl);
            }

        }

        //When the series is clicked, thicken the line and scroll the legend
        private void tChart1_ClickSeries(object sender, Series s, int valueIndex, MouseEventArgs e)
        {
            flClickedSeries = (FastLine)s;
            flClickedSeries.LinePen.Width = 6;
            bLineWasClicked = true;
            int index = tChart1.Series.IndexOf(s);

            //Now, to demonstrate how the number of displayed items grows and shrinks depending on which line
            //gets clicked...
            tChart1.Legend.FirstValue = index;


            //But what I really want to do is find out how many items (maximum) can appear in the legend at the 
            //current form size, and then 
            // if (index < MaxItemsInLegend)
            //{
            //     tChart1.Legend.FirstValue = 0;  
            //}
            //else if (index > NumberOfLines - MaxItemsInLegend)
            //{
            //     tChart1.Legend.FirstValue = (NumberOfLines - MaxItemsInLegend); 
            //}
            //else
            //{
            //     tChart1.Legend.FirstValue = index - (MaxItemsInLegend/2) ;
            //}
            //
            //This way, if I have 50 items of which only 5 can be displayed, then when I click Item#4 I should see
            //  [FastLine1, FastLine2, FastLine3, FASTLINE4, FastLine5]
            //When I click Item 47 I should see
            //  [FastLine46, FASTLINE47, FastLine48, FastLine49, FastLine50]
            //And when I click Item 20 I should see
            //  [FastLine18, FastLine19, FASTLINE20, FastLine21, FastLine22]



        }

        //Restore the clicked series line to normal thickness
        private void tChart1_MouseUp(object sender, MouseEventArgs e)
        {
            if (bLineWasClicked)
            {
                flClickedSeries.LinePen.Width = 1;
                bLineWasClicked = false;
            }
        }
    }
}